diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassGrowthPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassGrowthPatch.java
new file mode 100644
index 000000000..b76a184f9
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassGrowthPatch.java
@@ -0,0 +1,122 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicGrowthRubyglass;
+import net.minecraft.core.block.BlockLogicRotatable;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class WorldFeatureRubyglassGrowthPatch implements WorldFeatureInterface {
+
+	private final float tallGrowthChance;
+
+	private final TilePos scratchPos = new TilePos();
+	private final TilePos scratchSupportPos = new TilePos();
+	private final TilePos scratchOutwardPos = new TilePos();
+	private final TilePos scratchCubeQueryPos = new TilePos();
+
+	/**
+	 * Generates a mixed patch with a 60% chance for buds to grow into 2-tall crystals.
+	 */
+	public WorldFeatureRubyglassGrowthPatch() {
+		this(0.6F);
+	}
+
+	/**
+	 * Generates a configurable Rubyglass patch.
+	 * @param tallGrowthChance The chance (0.0F to 1.0F) that a crystal will attempt to grow 2 blocks tall.
+	 * Set to 0 to generate only buds.
+	 */
+	public WorldFeatureRubyglassGrowthPatch(float tallGrowthChance) {
+		this.tallGrowthChance = tallGrowthChance;
+	}
+
+	@Override
+	public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+		// Cache the static side array; Side.values() allocates a fresh array on every call.
+		final Side[] sides = Side.sides;
+
+		for(int i1 = 0; i1 < 20; i1++) {
+			int x1 = (tilePos.x() + random.nextInt(4)) - random.nextInt(4);
+			int y1 = (tilePos.y() + random.nextInt(4)) - random.nextInt(4);
+			int z1 = (tilePos.z() + random.nextInt(4)) - random.nextInt(4);
+
+			final TilePos pos = this.scratchPos.set(x1, y1, z1);
+
+			if (!world.isAirBlock(pos)) {
+				continue;
+			}
+
+			for (int s = 0, n = sides.length; s < n; s++) {
+				final Side side = sides[s];
+				final Direction growthDir = side.direction();
+				pos.add(growthDir.opposite(), this.scratchSupportPos);
+
+				if (!this.isValidSupport(world, this.scratchSupportPos)) {
+					continue;
+				}
+
+				int rot = BlockLogicRotatable.setDirection(0, growthDir);
+				pos.add(growthDir, this.scratchOutwardPos);
+
+				if (this.tallGrowthChance > 0.0F && world.isAirBlock(this.scratchOutwardPos) && random.nextFloat() < this.tallGrowthChance) {
+					world.setBlockTypeData(pos, Blocks.RUBYGLASS_GROWTH, BlockLogicGrowthRubyglass.STATE_BOTTOM | rot);
+					world.setBlockTypeData(this.scratchOutwardPos, Blocks.RUBYGLASS_GROWTH, BlockLogicGrowthRubyglass.STATE_TOP | rot);
+				} else {
+					world.setBlockTypeData(pos, Blocks.RUBYGLASS_GROWTH, BlockLogicGrowthRubyglass.STATE_BUD | rot);
+				}
+
+				break;
+			}
+		}
+		return true;
+	}
+
+	/**
+	 * Determines if the growth is allowed to attach to the given block.
+	 */
+	private boolean isValidSupport(@NotNull World world, TilePos pos) {
+		if (!world.isBlockNormalCube(pos)) {
+			return false;
+		}
+
+		Block<?> block = world.getBlockType(pos);
+
+		if (block == Blocks.RUBYGLASS_GROWTH) {
+			return false;
+		}
+
+		if (block == Blocks.RUBYGLASS_COLUMN ||
+				block == Blocks.RUBYGLASS_NODE ||
+				block == Blocks.COBBLE_NETHERRACK_CRYSTALLINE) {
+			return true;
+		}
+
+		if (block == Blocks.COBBLE_NETHERRACK) {
+			final TilePos checkPos = this.scratchCubeQueryPos;
+			final int px = pos.x();
+			final int py = pos.y();
+			final int pz = pos.z();
+
+			for (int x = -1; x <= 1; x++) {
+				for (int y = -1; y <= 1; y++) {
+					for (int z = -1; z <= 1; z++) {
+						checkPos.set(px + x, py + y, pz + z);
+						if (world.getBlockType(checkPos) == Blocks.COBBLE_NETHERRACK_CRYSTALLINE) {
+							return true;
+						}
+					}
+				}
+			}
+		}
+
+		return false;
+	}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSoulCatcherPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSoulCatcherPatch.java
new file mode 100644
index 000000000..4d9ab4857
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSoulCatcherPatch.java
@@ -0,0 +1,53 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class WorldFeatureSoulCatcherPatch implements WorldFeatureInterface {
+    private static final int SOULSAND_ATTEMPTS = 28;
+    private static final int OTHER_ATTEMPTS = 6;
+    private static final int SPORADIC_CHANCE_DENOM = 5;
+    private static final int OFFSET_RAND_BOUND = 3;
+
+    private final TilePos scratchGround = new TilePos();
+    private final TilePos scratchQuery = new TilePos();
+    private final TilePos scratchBelow = new TilePos();
+
+    @Override
+    public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+        final TilePos ground = this.scratchGround.set(tilePos.x(), tilePos.y(), tilePos.z());
+        while (world.isAirBlock(ground) && ground.y() > 0) {
+            ground.down();
+        }
+        if (ground.y() <= 0) { return false; }
+
+        final boolean seedOnSoulSand = world.getBlockType(ground) == Blocks.SOULSAND;
+        final int attempts = seedOnSoulSand ? SOULSAND_ATTEMPTS : OTHER_ATTEMPTS;
+
+        for (int i = 0; i < attempts; i++) {
+            final int qx = ground.x() + random.nextInt(OFFSET_RAND_BOUND) - random.nextInt(OFFSET_RAND_BOUND);
+            final int qy = ground.y() + 1 + random.nextInt(2) - random.nextInt(2);
+            final int qz = ground.z() + random.nextInt(OFFSET_RAND_BOUND) - random.nextInt(OFFSET_RAND_BOUND);
+            this.scratchQuery.set(qx, qy, qz);
+
+            if (!world.isAirBlock(this.scratchQuery)) { continue; }
+
+            this.scratchBelow.set(qx, qy - 1, qz);
+            final boolean overSoulSand = world.getBlockType(this.scratchBelow) == Blocks.SOULSAND;
+
+            if (!overSoulSand && random.nextInt(SPORADIC_CHANCE_DENOM) != 0) {
+                continue;
+            }
+
+            if (Blocks.SOUL_CATCHER.canStay(world, this.scratchQuery)) {
+                world.setBlockType(this.scratchQuery, Blocks.SOUL_CATCHER);
+            }
+        }
+        return true;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpireVent.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpireVent.java
new file mode 100644
index 000000000..fd316d6fb
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpireVent.java
@@ -0,0 +1,92 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3i;
+
+import java.util.Random;
+
+public class WorldFeatureSpireVent implements WorldFeatureInterface{
+
+    /**
+     * Maximum vertical drop allowed when scanning down for a placement surface.
+     * Caps the cost of feature placement when called inside large open caves.
+     */
+    private static final int MAX_DOWN_SCAN = 64;
+
+    @Override
+    public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePosc) {
+        if (!world.isAirBlock(tilePosc)) {
+            return false;
+        }
+
+        TilePos tilePos = new TilePos(tilePosc.x(), tilePosc.y(), tilePosc.z());
+
+        int scanned = 0;
+        while(world.isAirBlock(tilePos) && tilePos.y() - 1 > 0 && scanned < MAX_DOWN_SCAN) {
+            tilePos.down();
+            scanned++;
+        }
+
+        if (!world.getBlockType(tilePos).hasTag(BlockTags.NETHER_SURFACE_BLOCK)) {
+            return false;
+        }
+
+        if (hasSpace(world, tilePos.x(), tilePos.y(), tilePos.z())) {
+
+            Vector3i highestOffset = new Vector3i(0, 0, 0);
+            TilePos centerPos = new TilePos(tilePos.x(), tilePos.y(), tilePos.z());
+            TilePos queryPos = new TilePos();
+
+            for (int x1 = 0; x1 < 2; x1++) {
+                for (int z1 = 0; z1 < 2; z1++) {
+                    int height = random.nextInt(6) + 4;
+                    if(height > highestOffset.y) {
+                        highestOffset.set(x1, height, z1);
+                    }
+
+                    // Bottom third of each column gets scattered nethercoal ore.
+                    int oreRange = Math.max(1, height / 3);
+
+                    for(int y1 = 0; y1 < height; y1++){
+                        centerPos.add(x1, y1, z1, queryPos);
+                        if (y1 < oreRange && random.nextInt(2) == 0) {
+                            world.setBlockType(queryPos, Blocks.ORE_NETHERCOAL_BASALT);
+                        } else {
+                            world.setBlockType(queryPos, Blocks.BASALT);
+                        }
+                    }
+                }
+            }
+
+            for(int y1 = 0; y1 < 2; y1++){
+                centerPos.add(highestOffset.x, highestOffset.y + y1, highestOffset.z, queryPos);
+                world.setBlockType(queryPos, Blocks.THERMAL_VENT);
+            }
+
+            return true;
+        }
+
+        return false;
+    }
+
+    private boolean hasSpace(World world, int xc, int y, int zc){
+        TilePos queryPos =  new TilePos();
+
+        for (queryPos.y = y + 1; queryPos.y < y + 5; queryPos.y++) {
+            for (queryPos.x = xc; queryPos.x < xc + 2; queryPos.x++) {
+                for (queryPos.z = zc; queryPos.z < zc + 2; queryPos.z++) {
+                    if (!world.isAirBlock(queryPos)) {
+                        return false;
+                    }
+                }
+            }
+        }
+        return true;
+    }
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureChimney.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureThermalVent.java
similarity index 98%
rename from game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureChimney.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureThermalVent.java
index c895b7b97..be95987e0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureChimney.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureThermalVent.java
@@ -9,7 +9,7 @@ import org.joml.Vector2i;
 
 import java.util.Random;
 
-public class WorldFeatureChimney extends WorldFeature{
+public class WorldFeatureThermalVent extends WorldFeature{
 
     final double[][] RADIUS_MAPS = {
             {1.5D, 1.5D, 1D, 1D, 0D, 0D},
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureWallClump.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureWallClump.java
new file mode 100644
index 000000000..a4303ab4e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureWallClump.java
@@ -0,0 +1,78 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class WorldFeatureWallClump implements WorldFeatureInterface {
+    private final Block<?> placeBlock;
+    private final Block<?> targetBlock;
+    private final int maxClumpSize;
+
+    public WorldFeatureWallClump(Block<?> placeBlock, Block<?> targetBlock, int maxClumpSize) {
+        this.placeBlock = placeBlock;
+        this.targetBlock = targetBlock;
+        this.maxClumpSize = maxClumpSize;
+    }
+
+    @Override
+    public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePos) {
+
+        if (world.getBlockType(tilePos) != this.targetBlock) {
+            return false;
+        }
+
+        TilePos checkPos = new TilePos();
+        if (!hasAirNeighbor(world, tilePos, checkPos)) {
+            return false;
+        }
+
+        TilePos currentPos = new TilePos();
+        currentPos.set(tilePos);
+
+        world.setBlockType(currentPos, this.placeBlock);
+        int blocksPlaced = 1;
+
+        TilePos nextPos = new TilePos();
+        final Direction[] directions = Direction.ID_MAP;
+
+        for (int i = 0; i < this.maxClumpSize * 2 && blocksPlaced < this.maxClumpSize; i++) {
+            Direction dir = directions[random.nextInt(directions.length)];
+            nextPos.set(currentPos).add(dir);
+
+            if (isValid(world, nextPos, checkPos)) {
+                world.setBlockType(nextPos, this.placeBlock);
+                currentPos.set(nextPos);
+                blocksPlaced++;
+            }
+        }
+
+        return true;
+    }
+
+    /**
+     * Checks if the position is the target block AND is exposed to air on at least one side.
+     * Reuses checkPos to prevent memory allocation in loops.
+     */
+    private boolean isValid(@NotNull World world, TilePosc pos, TilePos checkPos) {
+        if (world.getBlockType(pos) != this.targetBlock) {
+            return false;
+        }
+        return hasAirNeighbor(world, pos, checkPos);
+    }
+
+    private boolean hasAirNeighbor(@NotNull World world, TilePosc pos, TilePos checkPos) {
+        final Direction[] directions = Direction.ID_MAP;
+        for (int d = 0, n = directions.length; d < n; d++) {
+            if (world.isAirBlock(checkPos.set(pos).add(directions[d]))) {
+                return true;
+            }
+        }
+        return false;
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/hanging/WorldFeatureHangingDungeon.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/hanging/WorldFeatureHangingDungeon.java
new file mode 100644
index 000000000..ff627fae1
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/hanging/WorldFeatureHangingDungeon.java
@@ -0,0 +1,198 @@
+package net.minecraft.core.world.generate.feature.hanging;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.WeightedRandomBag;
+import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.WorldFeatureInterface;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+
+import java.util.Random;
+
+public class WorldFeatureHangingDungeon {
+
+	public static final WeightedRandomBag<WeightedRandomLootObject> lootNormal = new WeightedRandomBag<>();
+
+	static {
+		lootNormal.addEntry(new WeightedRandomLootObject(Items.INGOT_STEEL_CRUDE.getDefaultStack(), 1, 6), 50.0F);
+		lootNormal.addEntry(new WeightedRandomLootObject(Items.FOOD_APPLE_GOLD.getDefaultStack()), 3.0F);
+		lootNormal.addEntry(new WeightedRandomLootObject(Items.DUST_REDSTONE.getDefaultStack(), 6, 24), 100.0F);
+		lootNormal.addEntry(new WeightedRandomLootObject(Items.DUST_GLOWSTONE.getDefaultStack(), 6, 24), 100.0F);
+		lootNormal.addEntry(new WeightedRandomLootObject(Items.NETHERCOAL.getDefaultStack(), 3, 9), 100.0F);
+		lootNormal.addEntry(new WeightedRandomLootObject(Blocks.TNT.getDefaultStack(), 4, 12), 50.0F);
+		lootNormal.addEntry(new WeightedRandomLootObject(Blocks.RAIL.getDefaultStack(), 12, 32), 50.0F);
+		lootNormal.addEntry(new WeightedRandomLootObject(Blocks.RAIL_POWERED.getDefaultStack(), 9, 16), 50.0F);
+		lootNormal.addEntry(new WeightedRandomLootObject(Items.INGOT_GOLD.getDefaultStack(), 5, 8), 100.0F);
+		lootNormal.addEntry(new WeightedRandomLootObject(Items.INGOT_IRON.getDefaultStack(), 5, 10), 100.0F);
+
+		for (int i = 0; i < 9; ++i) {
+			lootNormal.addEntry(new WeightedRandomLootObject(new ItemStack(Item.itemsList[Items.RECORD_13.id + i]), 1), 1.0F);
+		}
+
+		lootNormal.addEntry(new WeightedRandomLootObject(Blocks.PUMICE_DRY.getDefaultStack(), 2, 7), 100.0F);
+		lootNormal.addEntry(new WeightedRandomLootObject(Items.BONE.getDefaultStack(), 2, 7), 100.0F);
+		lootNormal.addEntry(new WeightedRandomLootObject(null), 180.0F);
+	}
+
+
+	public static class RandomType implements WorldFeatureInterface {
+		private final WorldFeatureInterface[] features;
+
+		public RandomType() {
+			this.features = new WorldFeatureInterface[] {
+				new Basalt(),
+				new Slate(),
+				new Gloomstone(),
+				new Netherrack()
+			};
+		}
+
+		@Override
+		public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePosc) {
+			int index = random.nextInt(features.length);
+			return features[index].place(world, random, tilePosc);
+		}
+	}
+
+	public static class Basalt implements WorldFeatureInterface {
+		private static final WeightedRandomBag<Block<?>> hangingDungeonBase = new WeightedRandomBag<>();
+
+		static {
+			hangingDungeonBase.addEntry(Blocks.BRICK_BASALT, 1);
+			hangingDungeonBase.addEntry(Blocks.BASALT_CARVED, .75);
+			hangingDungeonBase.addEntry(Blocks.BASALT_POLISHED, .10);
+		}
+
+		private static final WeightedRandomBag<Block<?>> hangingDungeonRope = new WeightedRandomBag<>();
+
+		static {
+			hangingDungeonRope.addEntry(Blocks.ROPE, 1);
+		}
+
+		private static final WorldFeatureInterface dungeon = new WorldFeatureHangingDungeonBase(
+			7,
+			32,
+			10,
+			6,
+			hangingDungeonBase, hangingDungeonRope,
+			lootNormal
+		);
+
+		public Basalt() {
+		}
+
+		@Override
+		public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePosc) {
+			return dungeon.place(world, random, tilePosc);
+		}
+
+	}
+
+	public static class Slate implements WorldFeatureInterface {
+		private static final WeightedRandomBag<Block<?>> hangingDungeonBase = new WeightedRandomBag<>();
+
+		static {
+			hangingDungeonBase.addEntry(Blocks.BRICK_SLATE, 1);
+			hangingDungeonBase.addEntry(Blocks.SLATE_POLISHED, .75);
+			hangingDungeonBase.addEntry(Blocks.SLATE_CARVED, .10);
+		}
+
+		private static final WeightedRandomBag<Block<?>> hangingDungeonRope = new WeightedRandomBag<>();
+
+		static {
+			hangingDungeonRope.addEntry(Blocks.ROPE, 1);
+		}
+
+		private static final WorldFeatureInterface dungeon = new WorldFeatureHangingDungeonBase(
+			7,
+			32,
+			10,
+			6,
+			hangingDungeonBase, hangingDungeonRope,
+			lootNormal
+		);
+
+		public Slate() {
+		}
+
+		@Override
+		public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePosc) {
+			return dungeon.place(world, random, tilePosc);
+		}
+
+	}
+
+	public static class Gloomstone implements WorldFeatureInterface {
+		private static final WeightedRandomBag<Block<?>> hangingDungeonBase = new WeightedRandomBag<>();
+
+		static {
+			hangingDungeonBase.addEntry(Blocks.BRICK_GLOOMSTONE, 1);
+			hangingDungeonBase.addEntry(Blocks.GLOOMSTONE_CARVED, .75);
+			hangingDungeonBase.addEntry(Blocks.GLOOMSTONE_POLISHED, .10);
+		}
+
+		private static final WeightedRandomBag<Block<?>> hangingDungeonRope = new WeightedRandomBag<>();
+
+		static {
+			hangingDungeonRope.addEntry(Blocks.ROPE, 1);
+		}
+
+		private static final WorldFeatureInterface dungeon = new WorldFeatureHangingDungeonBase(
+			7,
+			32,
+			10,
+			6,
+			hangingDungeonBase, hangingDungeonRope,
+			lootNormal
+		);
+
+		public Gloomstone() {
+		}
+
+		@Override
+		public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePosc) {
+			return dungeon.place(world, random, tilePosc);
+		}
+
+	}
+
+	public static class Netherrack implements WorldFeatureInterface {
+		private static final WeightedRandomBag<Block<?>> hangingDungeonBase = new WeightedRandomBag<>();
+
+		static {
+			hangingDungeonBase.addEntry(Blocks.BRICK_NETHERRACK, 1);
+			hangingDungeonBase.addEntry(Blocks.NETHERRACK_CARVED, .75);
+			hangingDungeonBase.addEntry(Blocks.NETHERRACK_POLISHED, .10);
+		}
+
+		private static final WeightedRandomBag<Block<?>> hangingDungeonRope = new WeightedRandomBag<>();
+
+		static {
+			hangingDungeonRope.addEntry(Blocks.ROPE, 1);
+		}
+
+		private static final WorldFeatureInterface dungeon = new WorldFeatureHangingDungeonBase(
+			7,
+			32,
+			10,
+			6,
+			hangingDungeonBase, hangingDungeonRope,
+			lootNormal
+		);
+
+		public Netherrack() {
+		}
+
+		@Override
+		public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePosc) {
+			return dungeon.place(world, random, tilePosc);
+		}
+
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/hanging/WorldFeatureHangingDungeonBase.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/hanging/WorldFeatureHangingDungeonBase.java
new file mode 100644
index 000000000..0e97f2f0a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/hanging/WorldFeatureHangingDungeonBase.java
@@ -0,0 +1,162 @@
+package net.minecraft.core.world.generate.feature.hanging;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.WeightedRandomBag;
+import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.TileEntityChest;
+import net.minecraft.core.block.entity.TileEntityMobSpawner;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.WorldFeatureInterface;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector2d;
+
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Random;
+
+public record WorldFeatureHangingDungeonBase(
+	int size, int maxDrop, int minDrop, int clumping,
+	WeightedRandomBag<Block<?>> base, WeightedRandomBag<Block<?>> ropes,
+	WeightedRandomBag<WeightedRandomLootObject> lootTable) implements WorldFeatureInterface {
+
+	public WorldFeatureHangingDungeonBase {
+		assert size >= 7;
+		// You don't want less than 7 because it will look ass.
+
+		assert size % 2 != 0;
+		// You don't want an even number because the spawner will be crooked.
+
+	}
+
+	@Override
+	public boolean place(@NotNull World world, @NotNull Random random, @NotNull TilePosc tilePosc) {
+		// 1. find the highest block from current Y.
+		// 2. check of an empty column on the 4 corners
+		// 3. place all ropes to a random height
+		// 4. fill platform
+
+		final TilePos[] corners = {
+			new TilePos(tilePosc.x(), tilePosc.y(), tilePosc.z()),
+			new TilePos(tilePosc.x() + this.size - 1, tilePosc.y(), tilePosc.z()),
+			new TilePos(tilePosc.x(), tilePosc.y(), tilePosc.z() + this.size - 1),
+			new TilePos(tilePosc.x() + this.size - 1, tilePosc.y(), tilePosc.z() + this.size - 1),
+		};
+
+		for (TilePos tilePos : corners) {
+			for (int currY = tilePos.y(); currY < world.getWorldType().getMaxY(world); currY++) {
+				if (currY > world.getWorldType().getMaxY(world)) {
+					return false;
+				}
+
+				var block = new TilePos(tilePos);
+				block.y = currY;
+
+				if (world.getBlockType(block).solid()) {
+					tilePos.y = currY;
+					break;
+				}
+			}
+		}
+
+		int minMaxHeight = Arrays.stream(corners).map(TilePos::y).min(Integer::compareTo).get();
+		int maxMaxHeight = Arrays.stream(corners).map(TilePos::y).max(Integer::compareTo).get();
+
+		if (minMaxHeight - tilePosc.y() < this.minDrop) {
+			return false;
+		}
+
+		var minHeight = minMaxHeight - MathHelper.clamp(random.nextInt(minMaxHeight - tilePosc.y()), this.minDrop, this.maxDrop);
+
+		if (maxMaxHeight - minHeight > this.maxDrop * 2) {
+			return false;
+		}
+
+		for (TilePos corner : corners) {
+			for (int y = minHeight; y < corner.y(); y++) {
+				var block = new TilePos(corner);
+				block.y = y;
+
+				var variant = ropes.getRandom(random);
+				world.setBlockTypeDataNotify(block, variant, 0);
+			}
+		}
+
+		for (int x = corners[0].x(); x <= corners[3].x(); x++) {
+			for (int z = corners[0].z(); z <= corners[3].z(); z++) {
+				var block = new TilePos(x, minHeight, z);
+				var variant = base.getRandom(random);
+
+				world.setBlockTypeData(block, variant, 0);
+			}
+		}
+
+		for (int step = 1; step < this.size -1; step++) {
+			var block = new TilePos(corners[0].x() + step, minHeight + 4, corners[0].z());
+			var block2 = new TilePos(corners[2].x() + step, minHeight + 4, corners[2].z());
+			var block3 = new TilePos(corners[0].x(), minHeight + 4, corners[0].z() + step);
+			var block4 = new TilePos(corners[1].x(), minHeight + 4, corners[1].z() + step);
+
+			var variant  = ropes.getRandom(random);
+			var variant2 = ropes.getRandom(random);
+			var variant3 = ropes.getRandom(random);
+			var variant4 = ropes.getRandom(random);
+
+			world.setBlockTypeNotify(block,  variant);
+			world.setBlockTypeNotify(block2, variant2);
+			world.setBlockTypeNotify(block3, variant3);
+			world.setBlockTypeNotify(block4, variant4);
+		}
+
+		final int half = this.size / 2;
+		var center = new TilePos(tilePosc.x() + half, minHeight + 1, tilePosc.z() + half);
+
+		world.setBlockTypeDataNotify(center, Blocks.MOBSPAWNER, 0);
+		var spawner = (TileEntityMobSpawner) world.getTileEntity(center);
+		if (spawner != null) {
+			spawner.setMobId("minecraft:zombie_pigman");
+		}
+
+		final var positions = new ArrayList<TilePos>();
+		positions.add(new TilePos(half, 0, 0));
+		positions.add(new TilePos(-half, 0, 0));
+		positions.add(new TilePos(0, 0, half));
+		positions.add(new TilePos(0, 0, -half));
+
+		for (int ii = 0; ii < 2; ii++) {
+			var chestPos = positions.remove(random.nextInt(positions.size() - 1));
+			chestPos.add(center.x(), center.y(), center.z());
+
+			world.setBlockTypeData(chestPos, Blocks.CHEST_PLANKS_OAK_PAINTED, DyeColor.RED.blockMeta * 16 + random.nextInt(3));
+
+			var chest = (TileEntityChest) world.getTileEntity(chestPos);
+
+			if (chest != null) {
+				for (int i = 0; i < 3 + random.nextInt(8); i++) {
+					chest.setItem((int) Math.floor(chest.getContainerSize() * random.nextFloat()), this.lootTable.getRandom(random).getItemStack(random));
+				}
+			}
+		}
+
+		if (random.nextInt(clumping) == 0) {
+			var vec2 = new Vector2d(1, 0)
+				.mul(MathHelper.rotateVec2(Math.PI * 2 * random.nextFloat()))
+				.mul(this.size * 2 + (this.size * random.nextFloat()));
+
+			var block = new TilePos(
+				tilePosc.x() + Math.floor(vec2.x()),
+				tilePosc.y() - 2 + random.nextInt(5),
+				tilePosc.z() + Math.floor(vec2.y())
+			);
+
+			this.place(world, random, block);
+		}
+
+		return true;
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java b/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
index f6847acde..98c8d6e15 100644
--- a/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
@@ -26,26 +26,33 @@ public class LightingEngineLegacy implements LightingEngine {
 
     @Override
     public boolean updatingLighting() {
-        if(this.lightingUpdatesCounter >= 50)
-        {
+        if(this.lightingUpdatesCounter >= 50) {
             return false;
         }
         this.lightingUpdatesCounter++;
-        try
-        {
-            for (int i = 499; !this.lightingToUpdate.isEmpty() && i >= 0; i--)
-            {
+        try {
+            // Why was this changed? During the development of 8.0, after adding many light sources to the nether,
+            // the lighting propagation/updates were getting caught up, and needed to be adjusted/upgraded
+
+            // Lighting updates are allowed to take up 7% of the tick budget max
+            final long timeBudgetNanos = 3_000_000L;
+            final long startTime = System.nanoTime();
+            int processed = 0;
+
+            while (!this.lightingToUpdate.isEmpty()) {
                 this.lightingToUpdate.remove(this.lightingToUpdate.size() - 1).performLightUpdate(this, this.world);
-                if (i == 0)
-                {
-                    return true;
+                processed++;
+
+                // Check the clock every 64 updates
+                if (processed % 64 == 0) {
+                    if (System.nanoTime() - startTime > timeBudgetNanos) {
+                        return true; // cut it short
+                    }
                 }
             }
 
-            return false;
-        }
-        finally
-        {
+            return false; // emptied the queue
+        } finally {
             this.lightingUpdatesCounter--;
         }
     }
@@ -80,9 +87,9 @@ public class LightingEngineLegacy implements LightingEngine {
             }
 
             int numLightingUpdates = this.lightingToUpdate.size();
-            if(numLightingUpdates > 5)
-            {
-                numLightingUpdates = 5;
+
+            if(numLightingUpdates > 12) {
+                numLightingUpdates = 12;
             }
 
             for(int i = 0; i < numLightingUpdates; i++)
diff --git a/game/core/src/main/java/net/minecraft/core/world/particle/ParticleEmitterRange.java b/game/core/src/main/java/net/minecraft/core/world/particle/ParticleEmitterRange.java
new file mode 100644
index 000000000..5ce6e423d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/particle/ParticleEmitterRange.java
@@ -0,0 +1,34 @@
+package net.minecraft.core.world.particle;
+
+public enum ParticleEmitterRange {
+    // BASIC fixed 16-block radius
+    BASIC(0.0f),
+
+    // SHORT scales to 25% of the players' particle render distance
+    SHORT(0.25f),
+
+    // MEDIUM scales to 50%
+    MEDIUM(0.5f),
+
+    // FAR scales to 75%
+    FAR(0.75f),
+
+    // EXTREME uses 100%
+    EXTREME(1.0f);
+
+    public final float multiplier;
+
+    ParticleEmitterRange(float multiplier) {
+        this.multiplier = multiplier;
+    }
+
+    public double getMaxDistanceSq(int renderDistanceChunks) {
+        if (this == BASIC) {
+            return 16.0 * 16.0;
+        }
+
+        double maxBlocks = (renderDistanceChunks * 16.0) * this.multiplier;
+        maxBlocks = Math.max(maxBlocks, 16.0);
+        return maxBlocks * maxBlocks;
+    }
+}
